<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX User Guide: tivx_target_kernel_priv.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
    </ul>
  </div>
<h1>tivx_target_kernel_priv.h</h1><a href="tivx__target__kernel__priv_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="preprocessor">#ifndef TIVX_TARGET_KERNEL_RPIV_H_</span>
<a name="l00067"></a><a class="code" href="tivx__target__kernel__priv_8h.html#ac065dc5faa22d3716740e58099f9f20e">00067</a> <span class="preprocessor"></span><span class="preprocessor">#define TIVX_TARGET_KERNEL_PRIV_H_</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00072"></a>00072 <span class="preprocessor">#endif</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>
<a name="l00074"></a>00074 <span class="preprocessor">#include &lt;<a class="code" href="vx__internal_8h.html" title="The top level TI OpenVX implementation header.">vx_internal.h</a>&gt;</span>
<a name="l00075"></a>00075 
<a name="l00086"></a><a class="code" href="group__group__tivx__target__kernel__cfg.html#gae392680631db17e50dff61e0f8bdc273">00086</a> <span class="preprocessor">#define TIVX_TARGET_KERNEL_MAX     (128u)</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>
<a name="l00092"></a><a class="code" href="group__group__tivx__target__kernel__priv.html#ga68c924652f2f73568d4dc6144459df04">00092</a> <span class="preprocessor">#define TIVX_TARGET_KERNEL_ID_INVALID       (0xFFFFu)</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>
<a name="l00094"></a>00094 
<a name="l00099"></a><a class="code" href="structtivx__target__kernel__t.html">00099</a> <span class="keyword">typedef</span> <span class="keyword">struct </span>_tivx_target_kernel {
<a name="l00100"></a>00100 
<a name="l00102"></a><a class="code" href="structtivx__target__kernel__t.html#a37060a651ac6882e3ebc802a2b12d902">00102</a>     <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a> kernel_id;
<a name="l00103"></a><a class="code" href="structtivx__target__kernel__t.html#a9bacd40aa71315686beebd55087bf562">00103</a>     <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a> target_id;
<a name="l00104"></a>00104 
<a name="l00105"></a><a class="code" href="structtivx__target__kernel__t.html#ab50b489692e922b2ecca512bc173024e">00105</a>     <a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569" title="The target kernel callback.">tivx_target_kernel_f</a> process_func;
<a name="l00106"></a><a class="code" href="structtivx__target__kernel__t.html#aa5a9a77c15d6508725ff92cfc40c429a">00106</a>     <a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569" title="The target kernel callback.">tivx_target_kernel_f</a> create_func;
<a name="l00107"></a><a class="code" href="structtivx__target__kernel__t.html#a162d1869fcf965af947ce95ca08884be">00107</a>     <a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569" title="The target kernel callback.">tivx_target_kernel_f</a> delete_func;
<a name="l00108"></a><a class="code" href="structtivx__target__kernel__t.html#abc8d5a0d77c2b11ee3e496b990306b88">00108</a>     <a class="code" href="group__group__tivx__target__kernel.html#gaa32576c061941da6b7ad3dd05d8c9569" title="The target kernel callback.">tivx_target_kernel_f</a> control_func;
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="structtivx__target__kernel__t.html#a29d852e531e6438320c0f864a5b9fa49">00110</a>     <span class="keywordtype">void</span> *caller_priv_arg;
<a name="l00111"></a>00111 } <a class="code" href="structtivx__target__kernel__t.html" title="Holds information about a target kernel instance.">tivx_target_kernel_t</a>;
<a name="l00112"></a>00112 
<a name="l00120"></a>00120 <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="group__group__tivx__target__kernel__priv.html#gac81cb5f6886a23d19b24265e6a87d8f5" title="Execute kernel on the target.">tivxTargetKernelExecute</a>(<a class="code" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8" title="Handle to instance of kernel on a target.">tivx_target_kernel_instance</a> target_kernel_instance, <a class="code" href="structtivx__obj__desc__t.html" title="Object descriptor.">tivx_obj_desc_t</a> *obj_desc[], uint16_t num_params);
<a name="l00121"></a>00121 
<a name="l00129"></a>00129 <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="group__group__tivx__target__kernel__priv.html#ga70bd6bb98783137e648551434fd182f9" title="Create kernel on the target.">tivxTargetKernelCreate</a>(<a class="code" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8" title="Handle to instance of kernel on a target.">tivx_target_kernel_instance</a> target_kernel_instance, <a class="code" href="structtivx__obj__desc__t.html" title="Object descriptor.">tivx_obj_desc_t</a> *obj_desc[], uint16_t num_params);
<a name="l00130"></a>00130 
<a name="l00138"></a>00138 <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="group__group__tivx__target__kernel__priv.html#gacaa42e1e119b79ee988d74d9b31a96ec" title="Delete kernel on the target.">tivxTargetKernelDelete</a>(<a class="code" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8" title="Handle to instance of kernel on a target.">tivx_target_kernel_instance</a> target_kernel_instance, <a class="code" href="structtivx__obj__desc__t.html" title="Object descriptor.">tivx_obj_desc_t</a> *obj_desc[], uint16_t num_params);
<a name="l00139"></a>00139 
<a name="l00148"></a>00148 <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="group__group__tivx__target__kernel__priv.html#ga9ec7ccc5134d81ce1224fa440affbabc" title="Control kernel on the target.">tivxTargetKernelControl</a>(<a class="code" href="group__group__tivx__target__kernel.html#ga333da592b786ba63f0a6c9c126eb1cd8" title="Handle to instance of kernel on a target.">tivx_target_kernel_instance</a> target_kernel_instance, <a class="code" href="structtivx__obj__desc__t.html" title="Object descriptor.">tivx_obj_desc_t</a> *obj_desc[], uint16_t num_params);
<a name="l00149"></a>00149 
<a name="l00155"></a>00155 <a class="code" href="group__group__tivx__target__kernel.html#ga0db4696f0a19630d7f741ab5650be01a" title="Handle to kernel on a target.">tivx_target_kernel</a> <a class="code" href="group__group__tivx__target__kernel__priv.html#ga157f15fc858c41cf95fe125be0cc59e5" title="Returns target kernel registered against this kernel ID and target ID.">tivxTargetKernelGet</a>(<a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a> kernel_id, <a class="code" href="vx__types_8h.html#a73d23cb932d31a69f44182054a987c85" title="Sets the standard enumeration type size to be a fixed quantity.">vx_enum</a> target_id);
<a name="l00156"></a>00156 
<a name="l00162"></a>00162 <a class="code" href="vx__types_8h.html#a64df90a05ff50c048d65ab77bc60e4f0" title="A formal status type with known fixed size.">vx_status</a> <a class="code" href="group__group__tivx__target__kernel__priv.html#gac8f389b1911b6edb882e85267559d069" title="Init target kernel module.">tivxTargetKernelInit</a>(<span class="keywordtype">void</span>);
<a name="l00163"></a>00163 
<a name="l00169"></a>00169 <span class="keywordtype">void</span> <a class="code" href="group__group__tivx__target__kernel__priv.html#ga111b4b61a8df459f04ac552e9e65d995" title="DeInit target kernel module.">tivxTargetKernelDeInit</a>(<span class="keywordtype">void</span>);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="preprocessor">#ifdef __cplusplus</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>}
<a name="l00174"></a>00174 <span class="preprocessor">#endif</span>
<a name="l00175"></a>00175 <span class="preprocessor"></span>
<a name="l00176"></a>00176 <span class="preprocessor">#endif</span>
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
